#!/bin/sh
#####################################################################
# ShellScript   : startXclock.sh (Bourne Shell)                     #
# Author        : Giuseppe La Rocca (giuseppe.larocca@ct.infn.it)   #
# Organization  : INFN - Via S. Sofia, 64 - 95123 Catania - ITALY   #
# Phone         : (+39) 095.378.55.03                               #
# Last Update   : December 23, 2005                                 #
#####################################################################
#
# Export DISPLAY environment to a remote machine.
#
export DISPLAY=193.206.208.67:0.0
#
# Define the input file used for rendering by CYCAS.
CYCAS_INPUT_FILE=$1
LOCAL_DIR=`pwd`
#
echo "Welcome! This is a simple interactive job.";echo
echo "About CYCAS."
echo "CYCAS is a piece of architectural software for drafting and"
echo "design in 2 + 3 dimensions. In addition to typical CAD"
echo "functions, CYCAS offers special elements and techniques for"
echo "architectural design. Therefore, you can easily design and"
echo "draft your ideas. Developing professional 2D presentation"
echo "of your design is worked out as fast as and as effective"
echo "as illustrating your design 3 dimensional. CYCAS enables"
echo "intuitive and uncomplicated handling of 2D and 3D elements. ";echo
echo "Do you want to start CYCAS (y/n) ? [Y]:"
read ANS
     case ${ANS} in
         Y|y)
	      #Launch application.
	      cd /usr/local/cycas3
              ./cycas.real ${LOCAL_DIR}/${CYCAS_INPUT_FILE} ;;

         *) 
	     echo "Have a nice day!" ;;
     esac

echo "That's all folks!!"
