#!/bin/bash
echo -n "Start compiling at.. ";date;echo " "
export CLASSPATH=.:jmusic.jar
javac MessageToSpheres.java
java MessageToSpheres portrait.txt

####################################
#                                  #
# Start rendering with POV-RAY-3.5 #
#                                  #
####################################
#
# Creation of a MessageToSpheres1.png
echo "Creation of MessageToSpheres1.png"
/usr/bin/povray ${PWD}/MessageToSpheres1.ini
echo "..Done!"
#
# Creation of a MessageToSpheres2.png
echo "Creation of MessageToSpheres2.png"
/usr/bin/povray ${PWD}/MessageToSpheres2.ini
echo "..Done!"
#
# Creation of a MessageToSpheres3.png
echo "Creation of MessageToSpheres3.png"
/usr/bin/povray ${PWD}/MessageToSpheres3.ini
echo "..Done!"
#
# Creation of a MessageToSpheres4.png
echo "Creation of MessageToSpheres4.png"
/usr/bin/povray ${PWD}/MessageToSpheres4.ini
echo "..Done!"
#
# Creation of a MessageToSpheres5.png
echo "Creation of MessageToSpheres5.png"
/usr/bin/povray ${PWD}/MessageToSpheres5.ini
echo "..Done!"
#
# Removing files used during the rendering.
rm -f *.ini
rm -f *.pov
echo -n "..Finish at ";date;echo "Have a nice day!"
