      program apple
      use fruit_module
      implicit none
      character(1000) line  ! later we will make this more dynamic
      character, dimension (:, :), allocatable:: grid
      character, dimension (:, :), allocatable:: value
      integer,   dimension (:, :), allocatable:: type
      real,      dimension (:, :), allocatable:: h
      character, dimension (:),    allocatable:: shades
      character, dimension (:),    allocatable:: shades_2
      character, dimension (:),    allocatable:: shades_3
      integer,   dimension (:),    allocatable:: typ
      real,      dimension (:),    allocatable:: valu
      integer                                 :: no_lines   =  0
      integer                                 :: max_length =  0
      integer                                 :: no_shades  =  0
      integer                                 :: ios        =  0
      integer                                 :: i          =  0
      integer                                 :: j          =  0
      integer                                 :: k          =  0
      integer                                 :: unit       = 10
      character(*), parameter           :: grid_dat   = 'grid.dat'
      character(*), parameter           :: grid_key   = 'grid.key'
      character(*), parameter           :: value_dat  = 'value.dat'
      character(*), parameter           :: value_key  = 'value.key'
      character(*), parameter           :: banana_inp = 'banana.inp'
      integer                           :: status

      open(unit=unit, file=grid_dat, status = 'old')
      read(unit, *, iostat=ios) line
      do while (ios == 0)
        no_lines   = no_lines+1
        max_length = max(max_length, len_trim(line))
        read(unit, *, iostat=ios) line
      end do
      close(unit=unit)

      open(unit=unit, file=grid_dat, status = 'old')
      allocate(grid(max_length, no_lines))
      allocate(type(max_length, no_lines))
      do j = no_lines, 1, -1
        read(unit, 100, iostat=ios) grid(1:max_length, j)
      end do
      close(unit=unit)

      open(unit=unit, file=grid_key, status = 'old')
      no_shades   = 0
      read(unit, *, iostat=ios) line
      do while (ios == 0)
        no_shades = no_shades+1
        read(unit, *, iostat=ios) line
      end do
      close(unit=unit)

      open(unit=unit, file=grid_key, status = 'old')
      allocate(shades  (no_shades))
      allocate(shades_2(0:no_shades))
      allocate(typ     (no_shades))
      do i = 1, no_shades
        read(unit, *) shades(i), typ(i)
      end do
      close(unit=unit)

      do k = 1, no_shades
        shades_2(typ(k)) = shades(k)
      end do

      do j = no_lines, 1, -1
        do i = 1, max_length
	type(i, j) = 0
	do k = 1, no_shades
            if (grid(i, j) == shades(k)) then
              type(i, j) = typ(k)
            end if
          end do
        end do
      end do

      max_length = 0
      no_lines   = 0
      open(unit=unit, file=value_dat, status = 'old')
      read(unit, *, iostat=ios) line
      do while (ios == 0)
        no_lines   = no_lines + 1
        max_length = max(max_length, len_trim(line))
        read(unit, *, iostat=ios) line
      end do
      close(unit=unit)

      allocate(h    (max_length, no_lines))
      allocate(value(max_length, no_lines))

      open(unit=unit, file=value_dat, status = 'old')
      do j = no_lines, 1, -1
        read(unit, 100, iostat=ios) value(1:max_length, j)
      end do
      close(unit=unit)

      open(unit=unit, file=value_key, status = 'old')
      no_shades = 0
      read(unit, *, iostat=ios) line
      do while (ios == 0)
        no_shades  = no_shades + 1
        max_length = max(max_length, len_trim(line))
        read(unit, *, iostat=ios) line
      end do
      close(unit=unit)

      open(unit=unit, file=value_key, status = 'old')
      allocate(shades_3(no_shades))
      allocate(valu    (no_shades))
      do k = 1, no_shades
        read(unit, *) shades_3(k), valu(k)
      end do
      close(unit=unit)

      do j = no_lines, 1, -1
        do i = 1, max_length
          h(i, j) = 0
          do k = 1, no_shades
            if (value(i, j) == shades_3(k)) then
              h(i, j) = valu (k)
            end if
          end do
        end do
      end do

      open(unit=unit, file=banana_inp, action = 'write')
      call write_header(unit, max_length, no_lines, status)
      if (status /= ok ) then
        call print_error(status)
      else
        call write_data  (unit, type,       h,        status)
      end if
      close (unit=unit)

  100 format(1000a1)  ! later we will make this more dynamic
      end
