#!/bin/bash
#
#-----------------------------------------------------------------------------------
date
ls -la
if [ ! -s start_Mozart_K545_csound.sh ]; then
  echo;
  echo " -----> missing file: start_Mozart_K545_csound.sh"; 
  exit 3;
fi
if [ ! -s Mozart_K545.orc ]; then
  echo;
  echo " -----> missing file: Mozart_K545.orc";
  exit 3;
fi
if [ ! -s Mozart_K545.sco ]; then
  echo;
  echo " -----> missing file: Mozart_K545.sco";
  exit 3;
fi

#---------------------------------------------------------------------------------------
#
# create environment for Csound
# 
# Execute Csound
#
csound -o Mozart_K545_csound.aiff -A Mozart_K545.orc Mozart_K545.sco
#
date
echo
echo " - check if all output files are there and not empty......."
#---------------------------------------------------------------------------------------------------
echo
ls -la
if [ ! -s Mozart_K545_csound.aiff ]; then
  echo;
  echo " ===> Missing output file :  Mozart_K545_csound.aiff     "; 
  exit 2;
fi
#
rm -f *.sco
rm -f *.orc

