#/bin/bash
#
#############################################################
# Author:  Giuseppe La Rocca (giuseppe.larocca@ct.infn.it)  #
#		-----------------------------		    #
#  Istituto Nazionale di Fisica Nucleare - Sez. di CATANIA  #
#		Via Santa Sofia,64 - 95123 ITALY	    #
#		-----------------------------		    #
#	+39.095.378.54.46 	+39.095.378.54.69	    #
#############################################################
#
echo "Start Execution.."
FILE2COMPILE1=$1
FILE2COMPILE2=$2
OBJECT2COMPILE1=`echo "$FILE2COMPILE1" | awk -F'.' '{print $1}'`
OBJECT2COMPILE2=`echo "$FILE2COMPILE2" | awk -F'.' '{print $1}'`

echo $FILE2COMPILE1
echo $OBJECT2COMPILE1
echo $FILE2COMPILE2
echo $OBJECT2COMPILE2
echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

#Setting the right permission for the execution of the file.
chmod 777 start_g95.sh

ls -l
echo

echo "Compilation the file $FILE2COMPILE1 using the g95 Fortran Compiler.."
/usr/bin/g95 -o "$OBJECT2COMPILE1" "$FILE2COMPILE1"
#Setting the right permission for the file.
echo "Setting the right permission for the file."
echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
chmod 777 "$OBJECT2COMPILE1"
./"$OBJECT2COMPILE1" >> bubble.out

echo "Compilation the file $FILE2COMPILE2 using the g95 Fortran Compiler.."
/usr/bin/g95 -o "$OBJECT2COMPILE2" "$FILE2COMPILE2"
#Setting the right permission for the file.
echo "Setting the right permission for the file."
echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
chmod 777 "$OBJECT2COMPILE2"
./"$OBJECT2COMPILE2" >> merge.out

echo Deleting the tmp files on the Worker Node.
echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
rm -f "$OBJECT2COMPILE1"
rm -f "$OBJECT2COMPILE2"
#rm -f *.f90

echo ..Done!!
echo @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
