;===================
; Anna Murchison
; Instruments file
; Homework #1
;===================
sr        =         44100
kr        =         4410
ksmps     =         10
nchnls    =         1

	instr 1                       ; p3=duration of note
; a simple instrument using the first waveform defined
k1      linen     p4, p6, p3, p7      ; p4=amp
a1      oscil     k1, p5, 1           ; p5=freq
        out       a1                  ; p6=attack time
        endin                         ; p7=release time

	instr 2
; an instrument with a vibrate addition. It also takes its 
; parameters in by decibels and octave.note, unlike the other two
irel      =         0.01                               ; set vibrato release time
idel1     =         p3 * p10                           ; calculate initial delay
isus      =         p3 - (idel1 + irel)                ; calculate remaining duration

iamp      =         ampdb(p4)
iscale    =         iamp * .333                        ; p4=amp
inote     =         cpspch(p5)                         ; p5=freq

k3        linseg    0, idel1, p9, isus, p9, irel, 0    ; p6=attack time
k1        linen     iscale, p6, p3, p7                 ; p8=vib rate
k2        oscil     k3, p8, 1                 

a3        oscil     k1, inote*.995+k2, 1               ; p9=vib depth
a2        oscil     k1, inote*1.005+k2, 1              ; p10=vib delay (0-1)
a1        oscil     k1, inote+k2, 1

          out       a1+a2+a3       
          endin
	
	instr 3
; a simple instrument using the second waveform defined
k1	linen	p4, p6, p3, p7
a1	oscil	k1, p5, 2
	out a1
	endin
